<?php
/*
*  @author metacreo <metacreo@newestvision.com>
*/

if (!defined('_PS_VERSION_')) {
    exit;
}

class HtmlMinifier extends Module
{
    public function __construct()
    {
        $this->name = 'htmlminifier';
        $this->tab = 'front_office_features';
        $this->version = '1.0.1';
        $this->author = 'metacreo';
        $this->need_instance = 0;
        $this->bootstrap = true;

        parent::__construct();

        $this->ps_versions_compliancy = ['min' => '1.7.8.10', 'max' => _PS_VERSION_];
        $this->displayName = 'Html Minifier';
        $this->description = 'Html minifier module Free.';
    }

    public function install()
    {
        return parent::install() && $this->registerHook('actionOutputHTMLBefore');
    }

    public function getContent()
    {
        $this->context->smarty->assign(['module_dir' => $this->_path]);
        $output = $this->fetch($this->local_path . 'views/templates/admin/configure.tpl');
        //return $output . $this->displayForm();
        return $output;
    }

    /*
    public function displayForm()
    {
        $form = [
            'form' => [
                // -- //
            ]
        ];
        $helper = new HelperForm();

        return $helper->generateForm([$form]);
    }
    */

    public function hookActionOutputHTMLBefore($params)
    {
        return $params['html'] = $this->minifier($params['html']);
    }

    private function minifier($html)
    {
        $search = [
            '/\>\s+\</m',
            '/[^\S]+\>/m',
            '/<!--(.|\s)*?-->/',
            '/"\s*([^"]*?)\s*"/',
            '%(?>[^\S ]\s*|\s{2,})(?=(?:(?:[^<]++|<(?!/?(?:textarea|pre|script)\b))*+)(?:<(?>textarea|pre|script)\b|\z))%ix'
        ];
        return preg_replace($search, ['> <', '>', '', '"$1"', ' '], $html);
    }
}